## zeek 3.2.3+ds2

=== debian/changelog ===
zeek (3.2.3+ds2-2build2) jammy; urgency=medium

  * No-change rebuild for private glibc symbols.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 04 Feb 2022 13:47:40 +0100

zeek (3.2.3+ds2-2build1.1.2) jammy; urgency=medium

  * No-change rebuild against libssl3

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 09 Dec 2021 00:23:34 +0000

zeek (3.2.3+ds2-2build1.1.1) impish; urgency=medium

  * No-change rebuild for glibc private symbol change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 12 Aug 2021 17:34:14 +0200

zeek (3.2.3+ds2-2build1.1) impish; urgency=medium

  * No-change rebuild for glibc private symbol change.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 16 Jul 2021 13:24:30 +0200

zeek (3.2.3+ds2-2build1) hirsute; urgency=medium

  * No change rebuild with fixed ownership.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Feb 2021 15:23:37 +0000

zeek (3.2.3+ds2-2) unstable; urgency=medium

  * Fix FTBFS on armel

 -- Hilko Bengen <bengen@debian.org>  Mon, 08 Feb 2021 22:33:03 +0100

zeek (3.2.3+ds2-1) unstable; urgency=medium

  * Add vendored highwayhash, libkqueue sources

 -- Hilko Bengen <bengen@debian.org>  Mon, 08 Feb 2021 18:31:24 +0100
