=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/,\
     dversionmangle=s/\+dfsg\d*$//,\
     uversionmangle=s/$/+ds1/;s/-rc/~rc/ \
    https://download.zeek.org (?:bro|zeek)-(\d.*)-minimal\.tar\.gz
